



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>关于oracle存储过程的一些知识点</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">关于oracle存储过程的一些知识点</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 09:49:05 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>一、创建一个存储过程，批量清空数据库中所有表的数据。</p>
<div>
<pre class="prettyprint linenums">--清空数据库中所有表的数据<br />
create or replace procedure truncateAllTables as<br />
v_sql varchar2(2000);<br />
CURSOR cur is<br />
       select table_name from user_tables order by table_name;<br />
begin<br />
--dbms_output.put_line('1111');<br />
for rows in cur loop<br />
v_sql := 'truncate table ' || rows.table_name;<br />
--dbms_output.put_line(v_sql);<br />
execute immediate v_sql;<br />
end loop;<br />
end;</pre>
</div>
<p>执行存储过程如下：</p>
<div>
<pre class="prettyprint linenums">exec truncateAllTables;</pre>
</div>
<p>二、如何在plsql中调用一个有参数的存储过程呢？</p>
<p>比如这样一个存储过程：</p>
<div>
<pre class="prettyprint linenums">create or replace procedure proc_CpNumber(cpNumber out varchar2) is<br />
begin<br />
   ....<br />
   -- 一些调试信息<br />
   dbms_output.put_line('==0'||cpNumber);<br />
   dbms_output.put_line('==0'||length(cpNumber));<br />
   --赋值<br />
   select 'E'||(to_number(substr(cpNumber,2,10))+1) into cpNumber from dual;<br />
   ......<br />
end;</pre>
</div>
<p>调用方法如下：</p>
<div>
<pre class="prettyprint linenums">--调用带有参数的存储过程<br />
declare<br />
cp_number varchar2(2000);<br />
begin<br />
proc_CpNumber(cp_number);<br />
dbms_output.put_line(cp_number);<br />
end;<br />
/</pre>
</div>
<p>三、在java代码中调用上面带有输出参数的存储过程如下：</p>
<div>
<pre class="prettyprint linenums">public class OracleDBHelper {<br />
    static final String DRIVER = "oracle.jdbc.driver.OracleDriver";<br />
    //开发环境<br />
    static final String URL = "jdbc:oracle:thin:@127.0.0.1:1521:orcl";

    static final String USER = "test123";<br />
    static final String PWD = "test123";

    private OracleDBHelper() {

    }<br />
    private static Connection con = null;

    public static Connection getConnection() {<br />
        if(con == null) {<br />
            try {<br />
                Class.forName(DRIVER);<br />
                con = DriverManager.getConnection(URL, USER, PWD);<br />
            } catch (ClassNotFoundException e) {<br />
                e.printStackTrace();<br />
            } catch (SQLException e) {<br />
                e.printStackTrace();<br />
            }<br />
        }<br />
        return con;<br />
    }

    public static void main(String[] args) throws Exception {<br />
        CallableStatement cStatement = OracleDBHelper.getConnection().prepareCall("{call proc_cpnumber(?)}");<br />
        cStatement.setString(1, "aa");<br />
        cStatement.registerOutParameter(1, java.sql.Types.VARCHAR);<br />
        cStatement.execute();<br />
        System.out.println(cStatement.getString(1));<br />
        OracleDBHelper.getConnection().close();<br />
    }<br />
}</pre>
</div>
<p>四、如果使用了mybatis框架，则调用上述存储过程，方法如下</p>
<p>首先定义调用的语句。</p>
<div>
<pre class="prettyprint linenums">&lt;select id="proc_cpnumber" statementType="CALLABLE" parameterType="java.util.HashMap" resultType="java.util.HashMap"&gt;<br />
&lt;![CDATA[<br />
    {call proc_cpnumber(#{eNumber,mode=OUT,jdbcType=VARCHAR})}<br />
]]&gt;<br />
&lt;/select&gt;</pre>
</div>
<p>java代码调用如下：</p>
<div>
<pre class="prettyprint linenums">    public synchronized String getNumber() {<br />
        String eNumber = "";<br />
        Map map=new HashMap();<br />
        getSqlSession().selectOne("proc_cpnumber",map);<br />
        eNumber=(String)map.get("eNumber");<br />
        return eNumber;<br />
    }</pre>
</div>
<p>其中为了保证获取到的number的唯一性，需要加上同步锁。其中getSqlSession是通过注入的SqlSessionDao的getSqlSession获取返回的。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8k5xk38.html">Httpclient请求数据&lpar;post&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8m6wj29.html">Debian 的 preinst&comma; postinst&comma; prerm&comma; 和 postrm 脚本</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq40lmj8.html">java攻城师之路--复习java web之jsp入门&lowbar;El表达式&lowbar;JSTL标签库</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdn62x9.html">Java I&sol;O操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mo2n69.html">揭开UTF-8的神秘面纱</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvzr0zq.html">Markdown 是什么？</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pj6ngy9.html">HW4&period;29</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvm33oq.html">hive 显示表分区真实对应数据路径</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0on50q.html">Qt入门（7）&mdash;&mdash;QApplication类</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd72oz8.html">BZOJ 1207&colon; &lbrack;HNOI2004&rsqb;打鼹鼠&lpar; dp &rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kppw469.html">js json string 互转</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pdyvy8.html">vue  vuex   提交                        this&period;&dollar;store&period;commit&lpar;&lbrace;type&colon; &amp;&num;39&semi;setSelectPro&amp;&num;39&semi;&comma; selectPro&colon; this&period;productId&rcub;&rpar;&semi;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj3preq.html">Java是如何解析xml文件的（DOM）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zoll1vq.html">three&period;js实现3D模型展示</a>
		</li>
						<li><a href="https://www.batexi.com/a/950yerm8.html">docker基础及安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mez1w6q.html">全部用startssl生成的证书，配置Apache使其支持SSL</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pxrwy8.html">【原】Java学习笔记024 - 包装类</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjno669.html">vue购物车和地址选配（三）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwxze79.html">过三关 Java冒泡排序选择排序插入排序小练习</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjw5yr9.html">2018&period;10&period;27 bzoj1984&colon; 月下&OpenCurlyDoubleQuote;毛景树&rdquo;（树链剖分）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qxnnx4z8.html">Android Studio Gradle构建脚本</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyddxn2q.html">【Problem solved】 error C2665&colon; &OpenCurlyDoubleQuote;loadimage&rdquo;&colon; 2 个重载中没有一个可以转换所有参数类型</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j00650q.html">javaNIO学习</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlmm0509.html">javaSE基础之记事本编程</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2ww1zwq.html">233&period; Number of Digit One  &ast;HARD&ast; -- 从1到n的整数中数字1出现的次数</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxnn76d8.html">Struts&plus;Spring&plus;Hibernate整合入门详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/96oovz39.html">为不同浏览器创建XMLHttpRequest对象</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e11zgj9.html">关于Can&amp;&num;39&semi;t connect to local MySQL server through socket &amp;&num;39&semi;&sol;tmp&sol;mysql&period;sock&amp;&num;39&semi; &lpar;2&rpar;的问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyddze2q.html">web开发常用的js验证&comma;利用正则表达式验证邮箱、手机、身份证等输入</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyddmvxq.html">test python</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
